Bug 136891 - 64-bit PPC GDB can't single step out of a signal handler
64-bit PPC GDB can't single step out of a signal handler
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: gdb (Show other bugs)
3.0
powerpc Linux
medium Severity medium
: ---
: ---
Assigned To: Andrew Cagney
Jay Turner
:
Depends On: 108886
Blocks: 117972 146413
  Show dependency treegraph
 
Reported: 2004-10-22 16:45 EDT by Andrew Cagney
Modified: 2015-01-07 19:08 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-12-21 14:37:21 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Andrew Cagney 2004-10-22 16:45:46 EDT
In the function epilogue, where the dynamic chain (of SP's) has been
torn down, GDB gets confused: it thinks it needs to run down one level
of the SP chain (to get the frame ID's stack address) when it doesn't.
 This, in turn, leads to wrong saved registers being saved, ...

In the case of single-stepping out of a signal handler and into a
signal trampoline, things get especially bad as the
signal-trampoline's frame doesn't actually have a valid SP chain.  It
leads to a bad memory access and that leads to a failed step.

The CFI information, if working, would fix this.
Comment 1 Andrew Cagney 2004-11-10 17:58:24 EST
GDB version:
  GNU gdb Red Hat Linux (6.1post-1.20040607.50rh)
Includes CFI for PPC and the test (sigstep.exp) passes.

Andrew
Comment 2 John Flanagan 2004-12-21 14:37:21 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2004-561.html

Note You need to log in before you can comment on or make changes to this bug.